module CukeParser
	module CukeModel
	  class CukeSuite
	  	#this will store all the elements for a specific feature
	  	attr_reader :date, :time, :runstamp, :duration, :converted_duration, :features, :browser, :os, :branch_number, :branch_build_tag, :url, :status
	  	attr_writer :duration, :converted_duration, :features, :status, :date, :time
	  	def initialize(date, time, runstamp, branch_build_tag, branch_number, os, url, browser)
	  		@date = date
	  		@time = time
	  		@runstamp = runstamp
	  		@duration = 0
	  		@converted_duration = 0
	  		@features = []
	  		@browser = browser
	  		@os = os
	  		@branch_number = branch_number
	  		@branch_build_tag = branch_build_tag
	  		@url = url
	  		@status = "" 
	  	end
	  	
	  	def to_csv
	  		#prints pretty csv format
	  		"#@date,#@time,#@duration,#@converted_duration,#@browser,#@os,#@branch_number,#@branch_build_tag,#@url,#@status"
	  	end
	  
	  	def to_csv_pretty
	  		return self.to_csv
	  	end
	  
	  	def getFullName
	  		#returns keyword + name
	  		fullName = @date + "_" + @time
	  		return fullName
	  	end
	  end
 	end
end