require 'nokogiri'
require 'json'
Dir[File.join(File.dirname(__FILE__),'parse_engine','*.rb')].each {|file| require file}
Dir[File.join(File.dirname(__FILE__),'report_engine','*.rb')].each {|file| require file}

module CukeParser
		
	def CukeParser.write_pretty(cuke,file)
		parser_utils = ParseEngine::ParserUtils.new
		parser_utils.pretty(cuke,file)
	end

	def CukeParser.write_build(cuke,file)
		parser_utils = ParseEngine::ParserUtils.new
		parser_utils.ugly(cuke,file)
	end
	
	def CukeParser.json(file_path)
		json_parser = ParseEngine::JsonParser.new
	  json_parser.get_build(file_path,"cucumber")
	end
	
	def CukeParser.json_custom(file_path,cuke_data)
		json_parser = ParseEngine::JsonParser.new
	  json_parser.get_build(file_path,cuke_data)
	end
	
	def CukeParser.json_complete(file_path,cuke_data,env_data)
		json_parser = ParseEngine::JsonParser.new
	  json_parser.get_complete_build(file_path,cuke_data,env_data)
	end


	def CukeParser.json_jenkins_list(file_path,timestamp)
		json_parser = ParseEngine::JsonParser.new
		json_parser.get_jenkins_build_list(file_path,timestamp)
	end

	def CukeParser.html(file_path)
		html_parser = ParseEngine::HtmlParser.new
		html_parser.get_build(file_path)
	end
	
	def CukeParser.generate_report(cuke,options)
	  reporter = ReportEngine::HtmlReporter.new(options[:output_dir],cuke.date.gsub("-","_")+"_"+cuke.time.gsub("-","_"),options[:json_file])
	  reporter.generate_report(cuke,options[:title])
	end
	
end #end CukeParser module