require 'fileutils'

module CukeParser
	module ReportEngine
		class HtmlReporter
			
			def initialize(output_dir,timestamp,json_file)
				@utils = ReporterUtils.new
				Dir.mkdir(output_dir) if !Dir.exists?(output_dir)
				@output_dir = output_dir+"/"+timestamp
				Dir.mkdir(@output_dir)
				Dir.mkdir(@output_dir+"/features")
				FileUtils.cp_r(Dir[Gem::Specification.find_by_name("cuke_parser").gem_dir + "/lib/assets/"],Dir[@output_dir])
				FileUtils.cp(File.new(json_file),Dir.new(@output_dir))
			end
			
			def generate_report(cuke,title)
				cuke_metrics = @utils.find_cuke_metrics(cuke)
				HomePage.new(@utils,cuke_metrics).create_home_page(cuke,@output_dir,title)
				feature_page = FeaturePage.new(@utils,cuke_metrics)
				cuke.features.each {|feature|	feature_page.create_feature_page(feature,@output_dir)}
			end
			
		end
	end
end